VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "FindFile sample from BlackBeltVB.com"
   ClientHeight    =   6480
   ClientLeft      =   2400
   ClientTop       =   1545
   ClientWidth     =   6660
   Height          =   6885
   Left            =   2340
   LinkTopic       =   "Form1"
   ScaleHeight     =   6480
   ScaleWidth      =   6660
   Top             =   1200
   Width           =   6780
   Begin VB.ListBox lstModified 
      Height          =   3765
      Left            =   4800
      TabIndex        =   9
      Top             =   2640
      Width           =   1755
   End
   Begin VB.ListBox lstType 
      Height          =   3765
      Left            =   3120
      TabIndex        =   8
      Top             =   2640
      Width           =   1695
   End
   Begin VB.ListBox lstSize 
      Height          =   3765
      Left            =   2160
      TabIndex        =   7
      Top             =   2640
      Width           =   975
   End
   Begin VB.ListBox lstFile 
      Height          =   3765
      Left            =   60
      TabIndex        =   6
      Top             =   2640
      Width           =   2115
   End
   Begin VB.CommandButton cmdStop 
      Cancel          =   -1  'True
      Caption         =   "Sto&p Search"
      Enabled         =   0   'False
      Height          =   495
      Left            =   4620
      TabIndex        =   5
      Top             =   1500
      Width           =   1215
   End
   Begin VB.CommandButton cmdSearch 
      Caption         =   "&Search Now"
      Default         =   -1  'True
      Height          =   495
      Left            =   420
      TabIndex        =   4
      Top             =   1500
      Width           =   1215
   End
   Begin VB.TextBox txtPath 
      Height          =   285
      Left            =   60
      TabIndex        =   3
      Top             =   1020
      Width           =   6495
   End
   Begin VB.TextBox txtFiles 
      Height          =   285
      Left            =   60
      TabIndex        =   1
      Top             =   360
      Width           =   6495
   End
   Begin VB.Label Label4 
      Caption         =   "Double Click to view the full path."
      Height          =   195
      Left            =   60
      TabIndex        =   14
      Top             =   2160
      Width           =   3555
   End
   Begin VB.Label Label3 
      BorderStyle     =   1  'Fixed Single
      Caption         =   " Modified"
      Height          =   255
      Index           =   3
      Left            =   4800
      TabIndex        =   13
      Top             =   2400
      Width           =   1755
   End
   Begin VB.Label Label3 
      BorderStyle     =   1  'Fixed Single
      Caption         =   " Type"
      Height          =   255
      Index           =   2
      Left            =   3120
      TabIndex        =   12
      Top             =   2400
      Width           =   1695
   End
   Begin VB.Label Label3 
      BorderStyle     =   1  'Fixed Single
      Caption         =   " Size"
      Height          =   255
      Index           =   1
      Left            =   2160
      TabIndex        =   11
      Top             =   2400
      Width           =   975
   End
   Begin VB.Label Label3 
      BorderStyle     =   1  'Fixed Single
      Caption         =   " Name"
      Height          =   255
      Index           =   0
      Left            =   60
      TabIndex        =   10
      Top             =   2400
      Width           =   2115
   End
   Begin VB.Label Label2 
      Caption         =   "&Look in"
      Height          =   255
      Left            =   60
      TabIndex        =   2
      Top             =   780
      Width           =   2535
   End
   Begin VB.Label Label1 
      Caption         =   "Search for files and folders na&med"
      Height          =   255
      Left            =   60
      TabIndex        =   0
      Top             =   120
      Width           =   2535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Text

' FindFile sample from BlackBeltVB.com
' http://blackbeltvb.com
'
' Written by Matt Hart
' Copyright 2001 by Matt Hart
'
' This software is FREEWARE. You may use it as you see fit for
' your own projects but you may not re-sell the original or the
' source code. Do not copy this sample to a collection, such as
' a CD-ROM archive. You may link directly to the original sample
' using "http://blackbeltvb.com/free/findfile.htm"
'
' No warranty express or implied, is given as to the use of this
' program. Use at your own risk.
'
' This shows how to find files through a recursive directory search.
' This is a modification of my Dirview sample.
'
' It also shows how to retrieve the file type from the registry, and
' how to syncronize multiple listboxes.
'
' NOTE that I use Option Compare Text at the top of the form's code.
' This allows the "Like" operator to ignore case.

Const MAX_PATH = 260
Const FILE_ATTRIBUTE_DIRECTORY = &H10
Const HKEY_CLASSES_ROOT = &H80000000
Const ERROR_SUCCESS = 0&

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Private Type VeryLongType
    lLow As Long
    lHigh As Long
End Type

Private Type CurrencyInType
    C As Currency
End Type

Private Declare Function FileTimeToLocalFileTime Lib "kernel32" (lpFileTime As FILETIME, lpLocalFileTime As FILETIME) As Long
Private Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Private Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpValue As String, lpcbValue As Long) As Long

Private Type DirInfo
    DirName     As String
End Type

Dim bCancel As Boolean, vFiles As Variant, colTypes As New Collection
Dim aFoundFiles() As String

Sub FindDirs(D$)
    If bCancel Then Exit Sub
    
    Dim C$
    Dim N As Integer, Srch$, i As Integer, NewD$
    
    C$ = D$
    If Right$(C$, 1) <> "\" Then C$ = C$ & "\"
    
    Srch$ = C$ & "*.*"
    ReDim Dees(1 To 10) As DirInfo
    Call LoadDirs(Dees(), N, Srch$)
    
    DoEvents
    
    If N Then
    Else
        Exit Sub
    End If
    
    For i = 1 To N
        NewD$ = RTrim$(Dees(i).DirName)
        Call FindDirs(NewD$)
        If bCancel Then Exit For
    Next
End Sub

Function LastPath$(P$)
    Dim i
    For i = Len(P$) To 1 Step -1
        If Mid$(P$, i, 1) = "\" Then
            LastPath$ = Mid$(P$, i + 1)
            Exit For
        End If
    Next
End Function

Private Sub LoadDirs(D() As DirInfo, N As Integer, Srch$)
    Dim a$, Max As Integer, i As Integer, k As Integer, W32 As WIN32_FIND_DATA, fHandle As Long, lResult As Long
    Dim oPath$, cSize As Currency, aType As String, aExt As String, S As SYSTEMTIME, dte As Date, FT As FILETIME
    Dim aFormat As String
    Max = UBound(D)
    N = 0
    
    oPath$ = Left$(Srch$, Len(Srch$) - Len(LastPath$(Srch$)))
    
    fHandle = FindFirstFile(Srch$, W32)

    If fHandle Then
        Do
            a$ = Left$(W32.cFileName, InStr(W32.cFileName, Chr$(0)) - 1)
            If a$ <> "." And a$ <> ".." Then
                If ((W32.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) > 0) Then
                    ' It's a directory
                    N = N + 1
                    If Max < N Then
                        Max = Max + 10
                        ReDim Preserve D(1 To Max) As DirInfo
                    End If
                    D(N).DirName = oPath$ & a$ & "\"
                Else
                    ' See if it matches what we are looking for
                    For k = 0 To UBound(vFiles)
                        If a$ Like vFiles(k) Then
                            lstFile.AddItem a$
                            cSize = VeryLongToCurrency(W32.nFileSizeLow, W32.nFileSizeHigh)
                            cSize = (cSize * 10000@) / 1024@
                            If cSize > 1 Then
                                aFormat = Format(cSize, "#######0.#")
                                If Right$(aFormat, 1) = "." Then
                                    aFormat = Left$(aFormat, Len(aFormat) - 1) & "k"
                                Else
                                    aFormat = aFormat & "k"
                                End If
                            Else
                                aFormat = VeryLongToCurrency(W32.nFileSizeLow, W32.nFileSizeHigh) * 10000
                            End If
                            lstSize.AddItem aFormat
                            On Local Error Resume Next
                            aExt = ""
                            i = InstrRev(a$, ".")
                            If i Then
                                If InstrRev(a$, "\") < i Then
                                    aExt = Mid$(a$, i + 1)
                                End If
                            End If
                            aType = ""
                            aType = colTypes(aExt)
                            If aType = "" Or Err.Number <> 0 Then
                                aType = GetFileType(aExt)
                                colTypes.Add aType, aExt
                            End If
                            If aType = "" Then
                                If aExt = "" Then
                                    lstType.AddItem "File"
                                Else
                                    lstType.AddItem aExt & " File"
                                End If
                            Else
                                lstType.AddItem aType
                            End If
                            FileTimeToLocalFileTime W32.ftLastWriteTime, FT
                            FileTimeToSystemTime FT, S
                            dte = S.wMonth & "/" & S.wDay & "/" & S.wYear & " " & S.wHour & ":" & S.wMinute
                            lstModified.AddItem Format(dte, "m/d/yyyy h:N am/pm")
                            ReDim Preserve aFoundFiles(UBound(aFoundFiles) + 1) As String
                            aFoundFiles(UBound(aFoundFiles)) = oPath & a$
                            Exit For
                        End If
                    Next
                End If
            End If
            DoEvents
            If bCancel Then Exit Do
            lResult = FindNextFile(fHandle, W32)
        Loop While lResult
        lResult = FindClose(fHandle)
    End If
End Sub

Private Sub cmdSearch_Click()
    cmdStop.Enabled = True
    cmdSearch.Enabled = False
    bCancel = False
    If Len(txtFiles.Text) Then
        vFiles = Split(Replace(txtFiles.Text, ";", ","), ",")
    Else
        ReDim vFiles(0) As Variant
        vFiles(0) = "*.*"
    End If
    ReDim aFoundFiles(0) As String
    Call FindDirs(txtPath.Text)
    cmdStop.Enabled = False
    cmdSearch.Enabled = True
End Sub

Private Sub cmdStop_Click()
    bCancel = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
    End
End Sub

Private Function GetFileType(aExt As String) As String
    Dim aDesc As String, aType As String, lLen As Long
    lLen = 128
    aDesc = Space$(lLen)
    If RegQueryValue(HKEY_CLASSES_ROOT, "." & aExt, aDesc, lLen) = ERROR_SUCCESS Then
        lLen = 128
        aType = Space$(lLen)
        If RegQueryValue(HKEY_CLASSES_ROOT, aDesc, aType, lLen) = ERROR_SUCCESS Then
            If lLen > 1 Then GetFileType = Left$(aType, lLen - 1)
        End If
    End If
End Function

Private Sub lstFile_Click()
    SyncList lstFile
End Sub

Private Sub lstFile_DblClick()
    MsgBox aFoundFiles(lstFile.ListIndex + 1)
End Sub

Private Sub lstModified_Click()
    SyncList lstModified
End Sub

Private Sub lstModified_DblClick()
    MsgBox aFoundFiles(lstFile.ListIndex + 1)
End Sub

Private Sub lstSize_Click()
    SyncList lstSize
End Sub

Private Sub lstSize_DblClick()
    MsgBox aFoundFiles(lstFile.ListIndex + 1)
End Sub

Private Sub lstType_Click()
    SyncList lstType
End Sub

Private Sub SyncList(lst As ListBox)
    ' You can leave in the ToolTipText stuff below for VB5 and above
    'lstFile.ToolTipText = aFoundFiles(lstFile.ListIndex + 1)
    lstFile.TopIndex = lst.TopIndex
    lstFile.ListIndex = lst.ListIndex
    
    'lstModified.ToolTipText = aFoundFiles(lstFile.ListIndex + 1)
    lstModified.TopIndex = lst.TopIndex
    lstModified.ListIndex = lst.ListIndex
    
    'lstSize.ToolTipText = aFoundFiles(lstFile.ListIndex + 1)
    lstSize.TopIndex = lst.TopIndex
    lstSize.ListIndex = lst.ListIndex
    
    'lstType.ToolTipText = aFoundFiles(lstFile.ListIndex + 1)
    lstType.TopIndex = lst.TopIndex
    lstType.ListIndex = lst.ListIndex
End Sub

Private Sub lstType_DblClick()
    MsgBox aFoundFiles(lstFile.ListIndex + 1)
End Sub

Private Function VeryLongToCurrency(lLow As Long, lHigh As Long) As Currency
    Dim VL As VeryLongType, CI As CurrencyInType
    VL.lLow = lLow
    VL.lHigh = lHigh
    LSet CI = VL
    VeryLongToCurrency = CI.C
End Function

' NOTE - Comment out this function for VB5 or later - it's here only for VB4.
Private Function InstrRev(aString As String, aSearch As String) As Long
    If Len(aString) = 0 Or Len(aSearch) = 0 Then Exit Function
    Dim k As Long
    For k = Len(aString) To 1 Step -1
        If Mid$(aString, k, Len(aSearch)) = aSearch Then
            InstrRev = k
            Exit Function
        End If
    Next
End Function

' NOTE - Comment out this function for VB5 or later - it's here for VB4.
Function Replace(aStr As String, aFind As String, aReplace As String) As String
    Dim i As Integer, aR As String
    aR = aStr
    i = InStr(aR, aFind)
    Do While i
        aR = Left(aR, i - 1) & aReplace & Mid(aR, i + Len(aFind))
        i = InStr(i + Len(aReplace), aR, aFind)
    Loop
    Replace = aR
End Function

' Important!! You can comment out this entire procedure in VB6.
' This function duplicates the new Split() function of VB6.
Function Split(aText As String, Optional vSrch As Variant) As Variant
    If IsMissing(vSrch) Then vSrch = " "
    Dim j As Long, k As Long, a As String
    ReDim v(0) As Variant
    a = aText
    k = InStr(a, vSrch)
    Do While k
        If j > UBound(v) Then ReDim Preserve v(0 To j) As Variant
        v(j) = Left$(a, k - 1)
        a = Mid$(a, k + Len(vSrch))
        k = InStr(a, vSrch)
        j = j + 1
    Loop
    If Len(a) Then
        If j > UBound(v) Then ReDim Preserve v(0 To j) As Variant
        v(j) = a
    End If
    Split = v
End Function
